function [feat] = feature_generation_CMC_batch_append_api(data, data_suffix_idx, feat_idx, model_fn, output_file_base,whitenning,numlayers,save_cmt_files)


load(model_fn);


features = data(:,feat_idx)';
Y1 = features;

% Make sure data is zero mean
%     numlayers = size(W_layer,1);
if whitenning
    Input = Y1 - repmat(mean_patch,1,size(Y1,2));
    Input = V * Input;
else
    Input = Y1;
end

for layer_idx = 1:numlayers
    Input_intercept = [ones(1,size(Y1,2)) ; Input];
    Input = G_layer{layer_idx,1} * sigmoid(W_layer{layer_idx,1} * Input_intercept);
end

feat = Input';


if save_cmt_files
    feat_full = [data(:,data_suffix_idx) feat]; % save other information in the data file
    feat_fn_txt = [output_file_base '_cmt.txt'];
    dlmwrite(feat_fn_txt, feat,'-append','delimiter','\t');
end

return
