function [X_sparse] = sparsity_enforcement(X,lambda)

X_abs = abs(X);
X_sparse = X;

[rows cols] = size(X);

for n = 1:cols
    x_abs = X_abs(:,n);
    x = X(:,n);
    [maxvals maxidx] = maxk(x_abs,lambda);
    zero_idx = setdiff([1:rows], maxidx);
    x(zero_idx) = 0;
    X_sparse(:,n) = x;
end